﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;

namespace hierarchicalDataTablesBinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Parent> data;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void XamDataGrid_Loaded(object sender, RoutedEventArgs e)
        {
            data = GenerateData();

            (sender as XamDataGrid).DataSource = data;
        }


        private ObservableCollection<Parent> GenerateData()
        {
            ObservableCollection<Parent> data = new ObservableCollection<Parent>();

            for (int i = 0; i < 5; i++)
            {
                Parent p = new Parent()
                {
                    ID = i,
                    FirstName = "Parent " + i,
                    LastName = "Parent " + i,
                    Email = "Parent " + i + "@parentColleciton.com",
                    Children = new ObservableCollection<Child>()
                };

                for (int j = 0; j < 5; j++)
                {
                    p.Children.Add(new Child
                    {
                        ID = j,
                        ParentID  = i,
                        Name = "Child " + j,
                        Age = i+j * 5
                    });
                }
                data.Add(p);
            }
            return data;
        }

        private void XamDataGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            if (e.FieldLayout.ParentField == null)
            {
                Field f = new Field() { Name = "ID", Label = "ID" };
                Field f1 = new Field() { Name = "FirstName", Label = "Name" };
                Field f2 = new Field() { Name = "Email", Label = "Email" };
                Field f3 = new Field() { Name = "Children" };

                e.FieldLayout.Fields.Add(f);
                e.FieldLayout.Fields.Add(f1);
                e.FieldLayout.Fields.Add(f2);
                e.FieldLayout.Fields.Add(f3);
            }

            if (e.FieldLayout.ParentFieldName != null && e.FieldLayout.ParentFieldName.Equals("Children"))
            {
                Field f = new Field() { Name = "Name", Label = "Name" };
                Field f1 = new Field() { Name = "Age", Label = "Age" };

                e.FieldLayout.Fields.Add(f);
                e.FieldLayout.Fields.Add(f1);
            }
        }
    }

    public class Parent
    {
        public int ID { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string Email { get; set; }
        public ObservableCollection<Child> Children { get; set; }
    }

    public class Child
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public int ParentID { get; set; }
        public int Age { get; set; }
    }
}
